; 
    include \masm32\include\masm32rt.inc
; 
;   If you are writing code for legacy hardware, comment out the following processor directives
; 

    .686p                                                   ; 686 privileged instructions
    .MMX                                                    ; multimedia extensions
    .XMM                                                    ; extended multimedia extensions

    include project.inc

; 

    .code                                                   ; start the code section of the application

start:                                                      ; the application entry point

    hInstance cgv(GetModuleHandle, NULL)                    ; create GLOBAL instance handle

    invoke DialogBoxParam,hInstance,1000,0,ADDR WndProc,0    ; Call the dialog box from the resource file

    invoke ExitProcess,eax                                  ; terminate the current running process

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL icce:INITCOMMONCONTROLSEX

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library
  ; --------------------------------------

    switch uMsg
      case WM_INITDIALOG
        GLOBAL hWnd dd ?                                    ; create a GLOBAL handle for the main window
        m2m hWnd, hWin                                      ; Copy hWin to GLOBAL variable
        fn SendMessage,hWin,WM_SETTEXT,0,"Window Title"     ; overwrite dialog original if necessary
        invoke SendMessage,hWin,WM_SETICON,1,rv(LoadIcon,hInstance,1)

      ; ----------------------------------------------
      ; NOTE "cgv" is a MACRO that creates the control
      ; handle in the uninitialised data section. Do
      ; not allocate a LOCAL or GLOBAL value as you
      ; will get "Duplicate label" errors. Also note
      ; that as GLOBAL values, each assigned name must
      ; be unique.
      ; ----------------------------------------------
        hButton1      cgv(GetDlgItem,hWin,1001)
        hButton2      cgv(GetDlgItem,hWin,1002)
        hCombo1       cgv(GetDlgItem,hWin,1003)
        hStatic1      cgv(GetDlgItem,hWin,1004)
        hListbox1     cgv(GetDlgItem,hWin,1005)
        hGroup1       cgv(GetDlgItem,hWin,1006)
        hRadio1       cgv(GetDlgItem,hWin,1007)
        hRadio2       cgv(GetDlgItem,hWin,1008)
        hCheck1       cgv(GetDlgItem,hWin,1009)
        hCheck2       cgv(GetDlgItem,hWin,1010)
        hProgress1    cgv(GetDlgItem,hWin,1011)

        return 1

      case WM_COMMAND
        switch wParam
          case 1001     ; Button1
            fn MessageBox,hWin,"Control handle = Button1","Control ID = 1001",MB_OK

          case 1002     ; Button2
            fn MessageBox,hWin,"Control handle = Button2","Control ID = 1002",MB_OK

          case 1007     ; Radio1
            fn MessageBox,hWin,"Control handle = Radio1","Control ID = 1007",MB_OK

          case 1008     ; Radio2
            fn MessageBox,hWin,"Control handle = Radio2","Control ID = 1008",MB_OK

          case 1009     ; Check1
            fn MessageBox,hWin,"Control handle = Check1","Control ID = 1009",MB_OK

          case 1010     ; Check2
            fn MessageBox,hWin,"Control handle = Check2","Control ID = 1010",MB_OK


        endsw

      case WM_PAINT
        invoke paint_proc,hWin
        return 0

      case WM_CLOSE
        exit_dialog:                                        ; jump to this label to close program
        invoke EndDialog,hWin,0

    endsw

    return 0

WndProc endp

; 

paint_proc proc hWin:DWORD

    LOCAL hDC:DWORD
    LOCAL Ps :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)                    ; get the device context handle
  ; --------------------------------------

  ; Write your GDI graphics code here

  ; --------------------------------------
    invoke EndPaint,hWin,ADDR Ps

    ret

paint_proc endp

; 

end start                                                   ; tell MASM where the application end is.

